from __future__ import annotations

from typing import Any

from .array import array_length as array_length
from .array import array_read as array_read
from .array import array_write as array_write
from .array import create_array as create_array
from .attribute import imag as imag
from .attribute import is_complex as is_complex
from .attribute import is_floating_point as is_floating_point
from .attribute import is_integer as is_integer
from .attribute import rank as rank
from .attribute import real as real
from .attribute import shape as shape
from .creation import arange as arange
from .creation import complex as complex
from .creation import diag as diag
from .creation import diagflat as diagflat
from .creation import empty as empty
from .creation import empty_like as empty_like
from .creation import eye as eye
from .creation import full as full
from .creation import full_like as full_like
from .creation import linspace as linspace
from .creation import meshgrid as meshgrid
from .creation import ones as ones
from .creation import ones_like as ones_like
from .creation import to_tensor as to_tensor
from .creation import tril as tril
from .creation import triu as triu
from .creation import zeros as zeros
from .creation import zeros_like as zeros_like
from .einsum import einsum as einsum
from .linalg import bincount as bincount
from .linalg import bmm as bmm
from .linalg import cholesky as cholesky
from .linalg import cholesky_solve as cholesky_solve
from .linalg import cond as cond
from .linalg import cov as cov
from .linalg import cross as cross
from .linalg import dist as dist
from .linalg import dot as dot
from .linalg import eig as eig
from .linalg import eigh as eigh
from .linalg import eigvals as eigvals
from .linalg import eigvalsh as eigvalsh
from .linalg import histogram as histogram
from .linalg import lstsq as lstsq
from .linalg import lu as lu
from .linalg import lu_unpack as lu_unpack
from .linalg import matmul as matmul
from .linalg import matrix_power as matrix_power
from .linalg import multi_dot as multi_dot
from .linalg import mv as mv
from .linalg import norm as norm
from .linalg import pinv as pinv
from .linalg import qr as qr
from .linalg import solve as solve
from .linalg import svd as svd
from .linalg import t as t
from .linalg import transpose as transpose
from .logic import allclose as allclose
from .logic import bitwise_and as bitwise_and
from .logic import bitwise_not as bitwise_not
from .logic import bitwise_or as bitwise_or
from .logic import bitwise_xor as bitwise_xor
from .logic import equal as equal
from .logic import equal_all as equal_all
from .logic import greater_equal as greater_equal
from .logic import greater_than as greater_than
from .logic import is_empty as is_empty
from .logic import is_tensor as is_tensor
from .logic import isclose as isclose
from .logic import less_equal as less_equal
from .logic import less_than as less_than
from .logic import logical_and as logical_and
from .logic import logical_not as logical_not
from .logic import logical_or as logical_or
from .logic import logical_xor as logical_xor
from .logic import not_equal as not_equal
from .manipulation import as_complex as as_complex
from .manipulation import as_real as as_real
from .manipulation import broadcast_tensors as broadcast_tensors
from .manipulation import broadcast_to as broadcast_to
from .manipulation import cast as cast
from .manipulation import chunk as chunk
from .manipulation import concat as concat
from .manipulation import expand as expand
from .manipulation import expand_as as expand_as
from .manipulation import flatten as flatten
from .manipulation import flatten_ as flatten_
from .manipulation import flip as flip
from .manipulation import gather as gather
from .manipulation import gather_nd as gather_nd
from .manipulation import moveaxis as moveaxis
from .manipulation import put_along_axis as put_along_axis
from .manipulation import put_along_axis_ as put_along_axis_
from .manipulation import repeat_interleave as repeat_interleave
from .manipulation import reshape as reshape
from .manipulation import reshape_ as reshape_
from .manipulation import roll as roll
from .manipulation import rot90 as rot90
from .manipulation import scatter as scatter
from .manipulation import scatter_ as scatter_
from .manipulation import scatter_nd as scatter_nd
from .manipulation import scatter_nd_add as scatter_nd_add
from .manipulation import shard_index as shard_index
from .manipulation import slice as slice
from .manipulation import split as split
from .manipulation import squeeze as squeeze
from .manipulation import squeeze_ as squeeze_
from .manipulation import stack as stack
from .manipulation import strided_slice as strided_slice
from .manipulation import take_along_axis as take_along_axis
from .manipulation import tensordot as tensordot
from .manipulation import tile as tile
from .manipulation import unbind as unbind
from .manipulation import unique as unique
from .manipulation import unique_consecutive as unique_consecutive
from .manipulation import unsqueeze as unsqueeze
from .manipulation import unsqueeze_ as unsqueeze_
from .manipulation import unstack as unstack
from .math import abs as abs
from .math import acos as acos
from .math import acosh as acosh
from .math import add as add
from .math import add_ as add_
from .math import add_n as add_n
from .math import addmm as addmm
from .math import all as all
from .math import amax as amax
from .math import amin as amin
from .math import angle as angle
from .math import any as any
from .math import asin as asin
from .math import asinh as asinh
from .math import atan as atan
from .math import atan2 as atan2
from .math import atanh as atanh
from .math import broadcast_shape as broadcast_shape
from .math import ceil as ceil
from .math import ceil_ as ceil_
from .math import clip as clip
from .math import clip_ as clip_
from .math import conj as conj
from .math import cos as cos
from .math import cosh as cosh
from .math import cumprod as cumprod
from .math import cumsum as cumsum
from .math import deg2rad as deg2rad
from .math import diagonal as diagonal
from .math import diff as diff
from .math import digamma as digamma
from .math import divide as divide
from .math import erf as erf
from .math import erfinv as erfinv
from .math import erfinv_ as erfinv_
from .math import exp as exp
from .math import exp_ as exp_
from .math import expm1 as expm1
from .math import floor as floor
from .math import floor_ as floor_
from .math import floor_divide as floor_divide
from .math import floor_mod as floor_mod
from .math import fmax as fmax
from .math import fmin as fmin
from .math import gcd as gcd
from .math import increment as increment
from .math import inner as inner
from .math import inverse as inverse
from .math import isfinite as isfinite
from .math import isinf as isinf
from .math import isnan as isnan
from .math import kron as kron
from .math import lcm as lcm
from .math import lerp as lerp
from .math import lerp_ as lerp_
from .math import lgamma as lgamma
from .math import log as log
from .math import log1p as log1p
from .math import log2 as log2
from .math import log10 as log10
from .math import logit as logit
from .math import logsumexp as logsumexp
from .math import max as max
from .math import maximum as maximum
from .math import min as min
from .math import minimum as minimum
from .math import mm as mm
from .math import mod as mod
from .math import multiplex as multiplex
from .math import multiply as multiply
from .math import nanmean as nanmean
from .math import nansum as nansum
from .math import neg as neg
from .math import outer as outer
from .math import pow as pow
from .math import prod as prod
from .math import rad2deg as rad2deg
from .math import reciprocal as reciprocal
from .math import reciprocal_ as reciprocal_
from .math import remainder as remainder
from .math import round as round
from .math import round_ as round_
from .math import rsqrt as rsqrt
from .math import rsqrt_ as rsqrt_
from .math import scale as scale
from .math import scale_ as scale_
from .math import sign as sign
from .math import sin as sin
from .math import sinh as sinh
from .math import sqrt as sqrt
from .math import sqrt_ as sqrt_
from .math import square as square
from .math import stanh as stanh
from .math import subtract as subtract
from .math import subtract_ as subtract_
from .math import sum as sum
from .math import tan as tan
from .math import tanh as tanh
from .math import tanh_ as tanh_
from .math import trace as trace
from .math import trunc as trunc
from .random import exponential_ as exponential_
from .random import multinomial as multinomial
from .random import normal as normal
from .random import poisson as poisson
from .random import rand as rand
from .random import randint as randint
from .random import randint_like as randint_like
from .random import randn as randn
from .random import randperm as randperm
from .random import standard_normal as standard_normal
from .random import uniform as uniform
from .random import uniform_ as uniform_
from .search import argmax as argmax
from .search import argmin as argmin
from .search import argsort as argsort
from .search import index_sample as index_sample
from .search import index_select as index_select
from .search import kthvalue as kthvalue
from .search import masked_select as masked_select
from .search import mode as mode
from .search import nonzero as nonzero
from .search import searchsorted as searchsorted
from .search import sort as sort
from .search import topk as topk
from .search import where as where
from .stat import mean as mean
from .stat import median as median
from .stat import numel as numel
from .stat import quantile as quantile
from .stat import std as std
from .stat import var as var
from .to_string import set_printoptions as set_printoptions

tensor_method_func: Any
magic_method_func: Any
